Subject: Re: bug#38529: Make --ad-hoc the default for guix environment proposed deprecation mechanism

From: zimoun <[email-masked]>
Date: Fri, 13 Dec 2019 17:32:33 +0100

Hi Gábor,

Sorry to be slow. :-)

On Fri, 13 Dec 2019 at 17:28, Gábor Boskovits <[email-masked]> wrote:

> So in a more algorithmic manner:
> 1. if ad-hoc and inputs-of is present at the same invocation: fail
> hard. (With an error like incompatible options present)
> 2. if only ad-hoc is present, then print a deprecation warning (yes,
> we could make this suspendable with an environment variable, like you
> described)
> 3. if only inputs-of present, then do the new behaviour.
> 4. if neither ad-hoc nor inputs-of present then
>   a. if GUIX_ENVIRONMENT_DEPRECATED is 1: do the current behaviour,
>   b. if GUIX_ENVIRONMENT_DEPRECATED is undefined, or is not 1: do the
> new behaviour.
>
> This would minimze friction, as there will be a few scripts falling under 4.
> This would also allow mirgating such scripts one by one. be defining
> GUIX_ENVIRONMENT_DEPRECATED to 1 in some startup file, and using
> GUIX_ENVIRONMENT_DEPRECATED=0 guix environment ... in scripts that are
> fixed to use the new syntax.
>
>
> What do you think?

I am perfectly aligned! :-)
It is exactly what I have tried to describe.
Sorry again for being slow.

Thank you.
Do you plan to implement it? Do I give a try?

All the best,
simon